#!/usr/bin/perl
###############################################################################
#
#	Funktion	Kovertiert Programme des LC-80 (binres Format) in WAV-Dateien  
#
#	Historie:	31.08.03 	by Volker Pohlers created
#
#	Stand:		$Id$
#
# $Log:$
#
###############################################################################

die <<"help" unless @ARGV;
$0 bin-file [sadr [fname]]
konvertiert LC-80-Dateien in wav-Dateien
Wave-Datei: 8bit, 22khz, mono
help

open BIN, $ARGV[0] or die;
binmode BIN;
undef $/;
$bin = <BIN>;
close BIN;

open WAV, ">$ARGV[0].wav" or die;
binmode WAV;
# WAV-Header
print WAV "RIFF\x00\x00\x00\x00WAVEfmt \x10\x00\x00\x00\x01\x00\x01\x00\x22\x56\x00\x00\x22\x56\x00\x00\x01\x00\x08\x00data\x00\x00\x00\x00";

#Chksum berechnen
$size=length $bin;
$chksum = 0;
for (my $i=0;$i<$size;$i++) { $chksum += ord(substr($bin,$i,1)) }
$chksum = $chksum & 255;

#Descriptor-Daten
$startadr = hex($ARGV[1] || '2000');
$endadr = $startadr + $size;
$filename = hex($ARGV[2] || 'FFFF');

printf "Filename: %.4lX\n", $filename;
printf "Startadr: %.4lX\n", $startadr;
printf "Endadr:   %.4lX\n", $endadr;
printf "Chksum:   %.2lX\n", $chksum;

#Ausgabe 4000 X 1Khz-Takte als Start-Sync Signal
sound1k (4000);

#Descriptor bertragen 7 Byte
# (2 Byte Filename, 2 Byte Startadr, 2 Byte Endadr, 1 Byte Chksum)
writebyte ($filename & 255);
writebyte ($filename >> 8);
writebyte ($startadr & 255);
writebyte ($startadr >> 8);
writebyte ($endadr & 255);
writebyte ($endadr >> 8);
writebyte ($chksum);

#Ausgabe 4000 X 2Khz-Takte als Mittel-Sync Signal
sound2k (4000);

#Daten bertragen
for (my $i=0;$i<$size;$i++) { writebyte(ord(substr($bin,$i,1))) }

#Ausgabe 4000 X 2Khz-Takte als End Sync. Signal
sound2k (4000);

$filesize = tell WAV;

close WAV;

#print $filesize; 

# WAV-"Korrektur"
open WAV, "+<$ARGV[0].wav" or die;
binmode WAV;

seek WAV, 4, SEEK_SET;
print WAV pack('L', $filesize-8);

seek WAV, 40, SEEK_SET;
print WAV pack('L', $filesize-44);

close WAV;

print "ok\n";

sub writewave {
	my ($cnt,$period1, $period2) = @_;
	foreach (1..$cnt) {
		for (my $i=0; $i<$period1; $i++) { print WAV chr(hex('20')) }
		for (my $i=0; $i<$period2; $i++) { print WAV chr(hex('E0')) }
	}
}

sub sound1k {
	my $waves = shift;
	#print "1k$waves ";
	writewave($waves, 11, 11);
}

sub sound2k {
	my $waves = shift;
	#print "2k$waves ";
	writewave($waves, 5, 6);
}

sub writebit {
	my $bit = shift;
	#print "$bit:";

	if ($bit==1) {
		sound2k(6);
		sound1k(6);
	} else {
		sound2k(12);
		sound1k(3);
	}
}	

sub writebyte {
	my $byte = shift;
	#printf "\n%.2lX ", $byte;
	my $bits = unpack 'B8', chr($byte);

	writebit (0);	# STARTBIT
	for (my $i=7;$i>=0;$i--) {  writebit(substr($bits,$i,1)) }
	writebit (1);	# STOPBIT
}

__END__
