; Programm 1002
; 3stimmiger Polyphoner Synthesizer mit Record-Funktion
; fr extra-Hardware
; Autor: Volker Pohlers, 1987
; reassembliert vp030910


; 20c5: c3 normal spielen, c9 aufnehmen
; 20bd: Tempo der Aufnahme
; 207c: Grundton C: 56 oder 4a
; 22fa-ff: 00
; 2340:	f1 c3 f0 20

		include	lc80

		org 2000h

 		ld	a, 0FFh
		out	(PIO2AC),a
		out	(PIO2AC),a
		out	(PIO2BC),a
		ld	a, 0F0h
		out	(PIO2BC),a
		jp	sub2
;
; Keyboardabfrage
;
; Init
sub0:		xor	a
		ld	(spe1), a
		ld	(spe2), a
		ld	(spe3), a
		ld	e, 1			; Zhler
		ld	b, 3			; uere Schleife
		ld	a, 11111110b
;
m2:		push	bc
		out	(KEYIN),a
		push	af
		in	a, (USERPORT)
		rrca				; A0 -> Cy
		nop				; jp nc, auswertung_spezialtasten
		nop
		nop
		rlca
		ld	b, 7			; innere Schleife
m3:		rlca				; A7 -> Cy
		jr	c, m7			; Taste nicht gedrckt
; Eintragen Tastencode (E) in (SPE1) ..(SPE3)
		push	af
		ld	d, 3
		ld	hl, spe1
m4:		ld	a, (hl)
		cp	0
		jr	nz, m5
		ld	(hl), e
		jr	m6
m5:		inc	hl
		dec	d
		jr	nz, m4
m6:		pop	af
m7:		inc	e
		djnz	m3			; Ende innere Schleife
		pop	af
		rlca
		pop	bc
		djnz	m2			; Ende uere Schleife
		ret
;
; Tontabelle
;
tontab0:	db 0E4h                         ; h1
		db 0D7h                         ; c
		db 0CBh                         ; cis
		db 0C0h                         ; d
		db 0B5h                         ; dis
		db 0ABh                         ; e
		db 0A1h                         ; f
		db  98h                         ; fis
		db  8Fh                         ; g
		db  87h                         ; gis
		db  80h                         ; a
		db  79h                         ; ais
tontab:		db  72h				; h
		db  6Ch                         ; c'
		db  66h                         ; cis'
		db  60h                         ; d'
		db  5Ah                         ; dis'
		db  55h                         ; e'
		db  50h                         ; f'
		db  4Ch                         ; fis'
		db  48h                         ; g'
		db  44h                         ; gis'
		db  40h                         ; a'
		db  3Ch                         ; ais'
		db  39h                         ; h'
		db  36h                         ; c''
		db  33h                         ; cis''
		db  30h                         ; d''
		db  2Dh                         ; dis''
		db  2Bh                         ; e''
		db  28h                         ; f''
		db  26h                         ; fis''
		db  24h                         ; g''
		db  22h                         ; gis''
		db  20h                         ; a''
		db  1Eh                         ; ais''
		db  1Ch                         ; h''
		db  1Bh                         ; c'''
		db  19h                         ; cis'''
		db  18h                         ; d'''
		db  17h                         ; dis'''
		db  15h                         ; e'''
		db  14h                         ; f'''
		db  13h                         ; fis'''
		db  12h                         ; g'''
;
; Tonausgabe
;
sub1:		call	sub0
		ld	de, tontab-1		; oder tontab0-1
		ld	h, 0
		ld	a, (spe1)
		cp	0
		jr	z, m11
		ld	l, a
		add	hl, de
		ld	a, 15h
		out	(CTC2),a
		ld	a, (hl)
		jr	m12
m11:		ld	a, 3
m12:		out	(CTC2),a
		ld	a, (spe2)
		cp	0
		jr	z, m13
		ld	l, a
		add	hl, de
		ld	a, 15h
		out	(CTC1),a
		ld	a, (hl)
		jr	m14
m13:		ld	a, 3
m14:		out	(CTC1),a
		ld	a, (spe3)
		cp	0
		jr	z, m15
		ld	l, a
		add	hl, de
		ld	a, 15h
		out	(CTC0),a
		ld	a, (hl)
		jr	m16
m15:		ld	a, 3
m16:		out	(CTC0),a
		ld	b, 18h			; Tempo der Aufnahme (Anzahl der Samples oro Zeiteinheit)
m17:		ld	c, 0
m18:		dec	c
		jr	nz, m18
		djnz	m17
		jp	sub1			; oder ret nop nop bei Aufnahme
;
; "Aufnahme". Abspeichern der Tasten im Memory
;
sub2:		ld	hl, membeg
		ld	(mempos), hl
m22:		call	sub1
		ld	hl, (mempos)
		ld	de, memend
		sbc	hl, de
		jr	c, m21
		halt

m21:		ld	hl, (mempos)
		ld	de, spe1
		ex	de, hl
		ld	bc, 3
		ldir
		ex	de, hl
		ld	(mempos), hl
		jp	m22			; (vp) Original: jp sub2+1
;
;
;
		db 0FFh

nmi:            ld      hl, membeg
	        ld      (mempos), hl
                ld      hl, (mempos)
                ld      de, 22FDh
                sbc     hl, de
                ei				; (vp) hier fehlt wohl noch ein bisschen ....

		db  80h
		db 0BBh
		db  95h
		db  81h
		db  91h
		db  88h
		db  80h
		db  91h
		db  80h
		db  81h
		db  80h
		db 0F6h
		db 0D8h
		db  91h
		db  81h
		db  91h
		db 0E6h
		db 0BDh
		db  90h
		db 0E1h
		db 0FBh
		db  90h

membeg:

		org	22f9h
memend:

		org	2300h

spe1:		ds	1
spe2:		ds	1
spe3:		ds	1
mempos:		ds	2

		end
