;********************    
;*                  *
;*   SYNTHESIZER    *
;*                  *
;*   FUER  LC-80    *
;*                  *
;*   BY V.POHLERS   *
;*                  *
;********************
;
;
	ORG 2000H
	LD IX,TAB
	LD A,0FFH				;Display dunkel
	OUT 0F4H,a
;
;********************
; TASTATURABFRAGE
;********************
TA:	SCF
	EX AF,af'
	LD C,0
	LD E,0FBH
T3:	LD A,E
	OUT 0F5H,a
	LD B,4
	IN a,0F9H
	LD D,A
T2:	RL D
	JR C,T1
	LD A,C
	EX AF,af'
T1:	INC C
	DJNZ T2
	RLC E
	JR C,T3
	EX AF,af'
	JR C,TA					;keine Taste betaetigt
;
;********************
; TASTCODEBERECHNUNG
;********************
	LD DE,TACOD
	ADD a,E
	LD E,A
	LD A,(DE)
	CP 10H
	JR C,TONB				;bei Zifferntaste
;
;********************
; TABZEIGERBERECHNUNG
;********************
	LD HL,TAB
	AND 7
	LD C,A
	RLC A
	RLC A
	RLC A
	SUB C
	ADD a,L
	LD L,A
	PUSH HL
	POP IX
	JP TA
;
;******************** 
; LD TONKONSTANTE
;********************
TONB:	LD H,(IX+0)
	LD L,(IX+1)
	ADD a,L
	LD L,A
	LD C,(HL)
;
;********************
; TONAUSGABE
;********************
	LD D,(IX+2)
	LD E,(IX+3)
TO6:	LD B,(IX+4)
TO5:	IN a,0F5H				;Ausgabe 1 Impuls
	XOR 2
	OUT 0F5H,a
	LD A,C
TO1:	DEC A
	JR NZ,TO1				;Zeitschleife mit Ton-
	CP (IX+5) 				;konstante
	JR Z,TO2				;keine Veraenderung bei
	LD A,D 					;(IX+5)=0
	CP 0
	JR Z,TO3
	INC C					;Ton erhoehen bei
	JR TO4					;(IX+2)=0
TO3:	DEC C					;Ton erniedrigen bei
TO4:	DJNZ TO5 				;(IX+2)=1
TO2:	XOR (IX+6)				;Ton wechselt staendig
	LD D,A 					;bei (IX+6)=1
	DEC E
	JR NZ,TO6
	JP TA
;
;********************     
; TAB TASTCODE
;********************
TACOD:	DB 10H					;Taste <EX>
	DB 12H					;Taste <LD>
	DB 11H					;Taste <ST>
	DB 0 
	DB 0					;Taste <0>
	DB 1					;Taste <1>
	DB 2					;Taste <2>
	DB 3					;Taste <3>
	DB 4					;Taste <4>
	DB 5					;Taste <5>
	DB 15H					;Taste <+>
	DB 7					;Taste <7>
	DB 8					;Taste <8>
	DB 9					;Taste <9>
	DB 0EH					;Taste <E>
	DB 0BH					;Taste <B>
	DB 0CH					;Taste <C>
	DB 0DH					;Taste <D>
	DB 0AH					;Taste <A>
	DB 0FH					;Taste <F>
	DB 13H					;Taste <ADR>
	DB 14H					;Taste <DAT>
	DB 6					;Taste <6>
	DB 16H					;Taste <->
;
;*******************
; EX: reiner,weicher Ton
;*******************
TAB:	dw 0D020H				;Tontabelle
	DB 0					;anschwellen
	DB 1					;Tondauer
	DB 1					;Variationsbreite
	DB 0					;rein
	DB 1					;beidseitig
;
;*******************
; LD: weiches Tongemisch
;*******************
	dw 0E020H				;Tontabelle
	DB 0					;anschwellen
	DB 4					;Tondauer
	DB 10H					;Variationsbreite
	DB 1					;Tongemisch
	DB 1					;beidseitig
;
;********************
; ST: harter,klarer Ton
;********************
	dw 0F020H				;Tontabelle
	DB 0					;anschwellen
	DB 2					;Tondauer
	DB 3					;Variationsbreite
	DB 1					;Tongemisch
	DB 1					;beidseitig
;
;********************
; ADR: Vibrato
;********************
	dw 00021H				;Tontabelle
	DB 0					;anschwellen
	DB 20H					;Tondauer
	DB 1					;Variationsbreite
	DB 0					;reiner Ton
	DB 1					;beidseitig
;
;********************
; DAT: Unterwassergeraeusch
;******************** 
	dw 1021H				;Tontabelle
	DB 0					;anschwellen
	DB 1					;Tondauer
	DB 80H					;Variationsbreite
	DB 1					;Tongemisch
	DB 0					;einseitig
;
;********************
; +: Maschinengewehr
;********************
	dw 2021H				;Tontabelle
	DB 1					;abschwellen
	DB 1					;Tondauer
	DB 58H					;Variationsbreite
	DB 1					;Tongemisch
	DB 0					;einseitig
;
;******************
; -: Geraeusch
;******************
	dw 2021H				;Tontabelle
	DB 1					;abschwellen
	DB 2					;Tondauer
	DB 80H					;Variationsbreite
	DB 1					;Tongemisch
	DB 1					;beidseitig
;
	ORG 20D0H
;*******************
; Tontabellen
;*******************
;
;<EX>
	dw 0A3B3H
	dw 8896H
	dw 6E7BH
	dw 5863H
	dw 444EH
	dw 333CH
	dw 232BH
	dw 161CH
;
;<LD>
	ds 10H
;
;<ST>
	ds 10H
;
;<ADR>
	ds 10H
;
;<DAT>
	dw 0D0E0H
	dw 0B0C0H
	dw 90A0H
	dw 7080H
	dw 5860H
	dw 4850H
	dw 3040H
	dw 1020H
;
;<+>,<->
	dw 0E0F0H
	dw 0C0D0H
	dw 0A0B0H
	dw 8090H
	dw 6070H
	dw 4050H
	dw 2030H
	dw 0010H
;
;
;+++++++++++++++++++++++++++++++++++
;
;   Dieser Synthesizer laeuft auf
;  beiden Monitoren des LC-80.
;  Startadresse ist 2000H.
;
;   Ueber die schwarzen (Funktions-)
;  Tasten werden die verschiedenen
;  Klaenge angewaehlt und gelten bis
;  zur Neuwahl. Die weissen Tasten
;  stellen die "Klaviatur" dar. Dabei
;  entspricht <0>...gis1
;             <1>...a1
;         bis <F>...h.

;        VIEL SPASS !!!
;
;   v.pohlers halle november 1986
;
;+++++++++++++++++++++++++++++++++++
;
;Hinweis: Der Programmteil 'TASTATURABRAGE'
;        liefert den DAK2-Tastencode. Die
;        Abarbeitungszeit ist fuer jede
;        Taste gleich.
;         Fuer die Tasten <LD>,<ST>,<ADR>
;        muss die Tontabelle noch vervoll-
;        staendigt werden.
;
END
