; Programm ???
; Schaltkreistester
; Autor: Volker Pohlers
;
;------------------------------------------------------------------------------
;
; Schaltkreistester fr TTL-Schaltkreise. Programm luft automatisch. Start ->
; Schaltkreis in Fassung -> Anzeige Typ. Bleibt die Anzeige dunkel, so Schaltkreis
; defekt oder nicht in Liste. Nchsten Schlatkreis einsetzen usw.
;
;
;         o   o   o   o   o   o   o
;	------------------------------
;	| +5V B0  B1  B2  B3  A1  A0 |
;	 )                           |
;	| A7  A6  A5  A5  A3  A2 Gnd |
;	------------------------------
;         o   o   o   o   o   o   o
;
; ber R=270 Ohm an PIO's
;
; s.auch Funkamateur xx/xx
;
;------------------------------------------------------------------------------

		CPU Z80

		include	lc80

		org 2000h

anf:		ld	ix, tabelle
beg:		ld	a,(ix)
		or	a
		jr	z,anf			; bei Tabellenende
;
		ld	a, 0FFh			; PIO-Mode 3 Port A
		out	(PIO2AC),a
		ld	a, (ix)			; E/A-Definition Port A
		out	(PIO2AC),a
		ld	a, 0FFh			; PIO-Mode 3 Port B
		out	(PIO2BC),a
		inc	ix
		ld	a, (ix)			; E/A-Definition Port B
		out	(PIO2BC),a
		inc	ix
		ld	b, (ix)			; Schleifenzhler
;
test:		inc	ix
		ld	a, (ix)
		ld	d, a
		out	(USERPORT),a		; Ausgabe gem. Wahrheitstabelle Port A
		inc	ix
		ld	a, (ix)
		ld	e, a
		out	(KEYIN),a		; Ausgabe gem. Wahrheitstabelle Port B
		in	a, (USERPORT)		; Einlesen und Ablegen in H, Port A
		ld	h, a
		in	a, (KEYIN)		; Einlesen und Ablegen in L, Port B
		ld	l, a
		or	a			; Cy = 0
		sbc	hl, de			; subtraktion HL-DE
		call	nz,fehler
		djnz	test
;
		ld	a,(flag)
		or	a
		jr	nz,m1
		call	DAK2			; Anzeige Typ
m1:		ld	b,6			; Herstellen Ausgangszustand f. nchsten Typ
m2:		inc	ix
		djnz	m2
		ld	a,0
		ld	(flag),a
		jp	beg
;
Fehler:		ld	a,1
		ld	(flag),a
		ret
;
flag:		db	?
tabelle:
;
; Aufbau Tabelle: pro Schaltkreis
;    1 Byte E/A Definition Port A	1 = IS-Ausgang, 0 = IS-Eingang
;    1 Byte E/A Definition Port B
;    1 Byte Testanzahl
;    pro Test 2 Byte: Testbyte Port A und Testbyte Port B	= log. Pegel
;    6 Byte Schaltkreisname
; Tabellenende 00
;
;D100D
		db 025h,0F4h 			; Portfestlegung Port A, Port B
		db 4 				; Anzahl der Tests
		db 025h,0F4h 			; 1. Test
		db 06Dh,0FDh 			; 2. Test
		db 0b7h,0f6h 			; 3. Test
		db 0dah,0FBh 			; 4. Test
		db 000h,0E9h,0E7h,0E7h,021h,0E9h; "D100D "
;D110D
		db 005h,0F2h
		db 8
		db 005h,0F2h
		db 00dh,0F7h
		db 055h,0FAh
		db 0a7h,0F2h
		db 05dh,0Ffh
		db 0Afh,0F7h
		db 0f7h,0Fah
		db 0fah,0fdh
		db 000h,0E9h,0E7h,021h,021h,0E9h
;D104
		db 055h,0F5h
		db 2
		db 055h,0F5h
		db 0aah,0Fah
		db 000h,0E9h,02bh,0e7h,021h,0E9h
;D174
		db 00fh,0F0h
		db 0ah
		db 015h,0f1h			; ? db 016h,0f1h
		db 08ah,0f8h                    ; ? db 089h,0f8h
		db 075h,0f7h                    ; ? db 076h,0f7h
		db 08ah,0f8h                    ; ? db 089h,0f8h
		db 09ah,0f9h                    ; ? db 099h,0f9h
		db 0b5h,0fbh                    ; ? db 0b5h,0fbh
		db 0d5h,0fdh                    ; ? db 0d6h,0fdh
		db 0fah,0ffh                    ; ? db 0fah,0ffh
		db 09ah,0f9h                    ; ? db 09ah,0f9h
		db 075h,0f7h                    ; ? db 076h,0f7h
		db 000h,0E9h,02bh,025h,021h,0E9h
;
		db 0
		end
