; Programm
; Lauflicht nach FA 5/85
; Autor: ?
; reassembliert und erweitert: Volker Pohlers
;
;------------------------------------------------------------------------------
; 
; An Port A werden Bytes ausgegeben, die ab Adr. BEG abgespeicherr sind in Form 
; von Blcken zu je 3 Byte. Das 1. Byte wird ausgegeben, das 2. Byte gibt die 
; Standdauer des 1. an. Das 3. Byte ist ein Steuerbyte. Die ersten 4 Bit geben die 
; Rcksprungweite (in Blcken) an, die unteren 4 Bit die Anzahl der 
; Wiederholungen. Damit knnen Teilprogramme mit einer maximalen Lnge von 15 
; Blcken bis zu 15 mal wiederholt werden (Bei 3. Byte = 0 keine Wiederholung). 
; Wenn 2. Byte = Zeitdauer = 0ffh, dann Rcksprung zur Adr. BEG. berlappungen im 
; Rcksprung sind mglich! Es werden nur die zuerst eingelesenen Werte gewertet 
; (d.h. die letzten in der Tabelle abgearbeitet)
; 
;------------------------------------------------------------------------------

		CPU Z80

		include	lc80

		org 2000h
;
;Initialisierung U-PIO A
;
start:		ld	a,0ffh
		out	PIO2AC,a
		cpl
		out	PIO2AC,a
;
		ld	hl,beg-1		; Startadresse fr Daten
a4:		inc	hl
a2:		ld	a,(hl)
		out	USERPORT,a
		inc	hl
		ld	a,(hl)
		inc	a
		and	a
		jr	nz,a1			; zum Anfang
		ld	hl,beg
		jr	a2
; Zeitschleife
a1:		dec	a
		ld	b,a
		ld	c,0
a3:		dec	c
		jr	nz,a3
		djnz	a3
;
		inc	hl
		ld	a,(hl)
		and	a
		jr	z,a4			; Sprung, wenn keine Wiederholung
; Berechnung Sprungweite
		and	0f0h
		call	re
		ex	af,af'
		ld	d,0
		ld	a,(hl)
		and	0fh
		sbc	hl,de
;
		ld	d,a
		inc	hl
		ex	af,af'
a6:		ex	af,af'
		ld	a,(hl)
		out	USERPORT,a
		inc	hl
		ld	a,(hl)
;Zeitschleife
		ld	b,a
		ld	c,0
a5:		dec	c
		jr	nz,a5
		djnz	a5
		inc	hl
		inc	hl
		ex	af,af'
		sub	a,3
		jr	nz,a6			; Sprung, wenn Wiederholung noch nicht fertig
		dec	d
		jr	z,a2			; Sprung, wenn Wiederholung noch nicht fertig
		ld	b,d
		xor	a
		ld	d,a
		sbc	hl,de
		ld	d,b
		ld	a,e
		jr	a6
;
re:		rra				; UP: E = (A shl 4) * 3
		rra
		rra
		rra
		ld	b,a
		add	a,b
		add	a,b
		ld	e,a
		ret
;
beg:						; Daten
		db	01100110b, 020h, 000h
		db	10100101b, 010h, 000h
		db	10011001b, 030h, 033h	; 3x 3 Blcke wiederholen
		db	01100110b, 0a0h, 000h
		db	10011001b, 020h, 024h	; 4x 2 Blcke wiederholen
		db	01111110b, 020h, 000h
		db	10111101b, 020h, 000h
		db	11011011b, 020h, 000h
		db	11100111b, 020h, 000h
		db	11011011b, 020h, 000h
		db	10111101b, 020h, 000h
		db	01111110b, 020h, 065h	; 5x 6 Blcke wiederholen
		db	00100100b, 0ffh		; das wird nicht ausgegeben!

; anderes Beipspiel
;		db	01110111b, 010h, 000h
;		db	10111011b, 010h, 000h
;		db	11011101b, 010h, 000h
;		db	11101110b, 010h, 044h
;		db	11011101b, 0a0h, 023h
;		db	01100110b, 020h, 000h
;		db	10100101b, 010h, 000h
;		db	10011001b, 030h, 033h
;		db	01100110b, 0a0h, 000h
;		db	10011001b, 040h, 023h
;		db	01111110b, 020h, 000h
;		db	10111101b, 020h, 000h
;		db	11011011b, 020h, 000h
;		db	11100111b, 020h, 000h
;		db	11011011b, 020h, 000h
;		db	10111101b, 020h, 000h
;		db	01111110b, 020h, 044h
;		db	00100100b, 0ffh

		end
		
