; Programm
; Spielautomat (Einarmiger Bandit)
; Autor: Gunther Zielosko
; "Hinweise zur Anwendung des Lerncomputers LC 80", Teil 3, Seite 57-64
;------------------------------------------------------------------------------
;------------------------------------------------------------------------------

		CPU Z80

		include	lc80

		org 2000h

; 10,00 M in Bank laden
		ld	hl,1000h
		ld	(2216h),hl
; 03 in 2211 eintragen
m1:		ld	a,03
		ld	(2211h),a
; Speicherbereich von 2200 bis 220c lschen
		ld	b,0ch
		ld	hl,2200h
		ld	a,0
m2:		ld	(hl),a
		inc	hl
		djnz	m2
		ld	ix,2200h		; Anzeigebereich 1
m3:		call	rotanz
		cp	05h			; '1'?  1. Ziffer
		jr	nz,m3			; Stop?
		call	stop
m4:		call	rotanz
		cp	06h			; '2'?  2. Ziffer
		jr	nz,m4			; Stop?
		call	stop
m5:		call	rotanz
		cp	07h			; '3'?  3. Ziffer
		jr	nz,m5			; Stop?
		call	SOU1K			; original: SOU1K+1
		call	vergleich
; Wenn Gewinn=0, dann B mit Gewinnzahl (3 oder 9) laden und B-mal Wechselton erzeugen
		ld	a,(2206h)
		cp	0
		jr	z,m7
		ld	b,a
m6:		push	bc
		call	SOU1K			; original: SOU1K+1
		call	SOU2K
		pop	bc
		djnz	m6
m7:		call	bilanz
m8:		call	anz
		cp	04h			; '0'? Neues Spiel?
		jr	z,m1
		cp	0ah			; '+'? Anzeige des Bankguthabens?
		jr	nz,m8
; Eintragen des Bankguthabens in Anzeigebereich 2, Lschen der letzten Stellen,
; Setzen des Dezimalpunktes, Anzeige
		ld	de,(2216h)
		call	ADRSDP
		ld	hl,0
		ld	(DATLED),hl
		ld	hl,DATLED+4
		set	4,(hl)
		ld	ix,DATLED
m9:		call	dak1
		cp	0			; '0'? Neues Spiel?
		jr	nz,m9
		jr	m1
;
rotanz:		
; Erzeugen der 3 rollenden Ziffern (Anzahl der noch rollenden Ziffern in B)
		ld	b,(ix+11h)
		ld	hl,2209h
r1:		ld	a,(hl)
		inc	a
		cp	7			; Endzahl+1
		jr	nz,r2
		ld	a,1			; Anfangszahl
r2:		ld	(hl),a
		inc	hl
		djnz	r1
; bertragen der 3 rollenden Ziffern in den 7-Segment-Code und Ablage
; im Anzeigebereich 1
anz:		ld	b,3
		ld	hl,2209h
		ld	de,2203h
r3:		ld	a,(hl)
		call	oneseg
		ld	(de),a
		inc	hl
		inc	de
		djnz	r3
		call	dak2			; Anzeige
		ret
;
Stop:
; Herabsetzen der Anzahl der rotierenden Ziffern
		ld	a,(2211h)
		dec	a
		ld	(2211h),a
		call	SOU1K			; original: SOU1K+1
		ret
;
vergleich:
; Vergleich der 1. mit der 2. Ziffer
		ld	hl,220bh
		ld	a,(hl)
		dec	hl
		cp	(hl)
		jr	nz,v1
; Gewinn 3, wenn 1. und 2. Ziffer gleich, Umformen in 7-Segment-Code
		ld	a,3
		ld	(2206h),a
		call	oneseg
		ld	(2200h),a
; Vergleich der 2. mit der 3. Ziffer
		ld	a,(hl)
		dec	hl
		cp	(hl)
		jr	nz,v1
; Gewinn 9, wenn 1., 2. und 3. Ziffer gleich, Umformung
		ld	a,9
		ld	(2206h),a
		call	oneseg
		ld	(2200h),a
v1:		ret
;
bilanz:
; Gewinnziffer 4x links verschieben (aus 09 wird 90), Ergebnis in Register D laden
		ld	a,(2206h)
		rlca
		rlca
		rlca
		rlca
		and	a,0f0h
		ld	d,a
; Gewinn vom Guthaben (Groschen) abziehen, bei bertrag Markbetrag um 1 vermindern,
; neue Guthaben abspeichern
		ld	a,(2216h)
		sub	d
		daa
		ld	(2216h),a
		jr	nc,b1
		ld	a,(2217h)
		sub	1
		daa
		ld	(2217h),a
; Spieleinsatz (10) zu Guthaben (Groschen) addieren, bei bertrag Markbetrag um 1
; erhhen, Guthaben abspeichern
b1:		ld	a,(2216h)
		add	a,10h
		daa
		ld	(2216h),a
		jr	nc,b2
		ld	a,(2217h)
		add	a,1
		daa
		ld	(2217h),a
b2:		ret
;

;; Anzeigebereich 1, Z1-Z3 rollende Ziffern, G Gewinn
;2200-2205	'G',' ',' ','Z3','Z2','Z1'	
;2206-220B	G,,,Z3,Z2,Z1
;2211		D - Anzahl der noch rollenden Ziffern
;2216		B1 - Guthaben Groschen
;2217		B10 - Guthaben Mark
;; Anzeigebereich 2
;23F2-23F7	' ',' ',2 Stellen Groschen, 2 Stellen Mark
		
		
		end