; Programm D100
; Schaltkreistest
; Autor: Gunther Zielosko
;
;------------------------------------------------------------------------------
;
; s. "Hinweise zur Anwendung des Lerncomputers LC 80", Teil 1, Seite 63-76
;
;------------------------------------------------------------------------------

		CPU Z80

		include	lc80

		org 2000h

start:		ld	ix, ic_test
		call	DAK1
		cp	1Eh			; Taste ST?
		jr	nz, start
;
test1:		ld	iy, ic_test+6
		ld	a, 0FFh			; PIO-Mode 3 Port A
		out	(PIO2AC),a
		ld	a, (iy+0)		; E/A-Definition Port A
		out	(PIO2AC),a
		inc	iy
		ld	a, 0FFh			; PIO-Mode 3 Port B
		out	(PIO2BC),a
		ld	a, (iy+0)		; E/A-Definition Port B
		out	(PIO2BC),a
		inc	iy
		ld	b, (iy+0)		; Anzahl der Tests
		inc	iy
		inc	iy
test2:		ld	a, (iy+0)
		ld	d, a
		out	(USERPORT),a		; Ausgabe gem. Wahrheitstabelle Port A
		inc	iy
		ld	a, (iy+0)
		ld	e, a
		out	(KEYIN),a		; Ausgabe gem. Wahrheitstabelle Port B
		in	a, (USERPORT)		; Einlesen und Ablegen in H, Port A
		ld	h, a
		in	a, (KEYIN)		; Einlesen und Ablegen in L, Port B
		ld	l, a
		inc	iy
		sbc	hl, de			; subtraktion HL-DE
		jr	nz, test3
		djnz	test2
;
		ld	ix, txt_pass		; Anzeige PASS
		call	DAK2
		or	a
		jp	test1
;
test3:		ld	ix, txt_fail		; Anzeige FAIL
		call	DAK2
		or	a
		jp	test1			; Testwiederholung (Dauerlauf!)

		org	2080h

txt_pass:	db 000h,0AEh,0AEh,06Fh,04Fh	; " PASS "
txt_fail:	db 000h,0C2h,021h,06Fh,04Eh,000h; " FAIL "

		org 	2100h

ic_test:	db 000h,0E9h,0E7h,0E7h,021h,0E9h; "D100D "
		db 045h,0F4h 			; Portfestlegung Port A, Port B
		dw    4 			; Anzahl der Tests
		db 045h,0F4h 			; 1. Test
		db 0D7h,0F6h 			; 2. Test
		db 06Dh,0FDh 			; 3. Test
		db 0BAh,0FBh 			; 4. Test

;D110
;		db 000h,0E9h,0E7h,021h,021h,0E9h; "D110D "
;		db 025h,0F0h
;		dw    8
;		db 025h,0F4h
;		db 077h,0F0h
;		db 0A5h,0FAh
;		db 02Dh,0F5h
;		db 0F7h,0FAh
;		db 07Fh,0F5h
;		db 0ADh,0FFh
;		db 0DAh,0FFh
;D104D
;		db 000h,0E9h,02bh,0e7h,021h,0E9h
;		db 0A5h,0FAh
;		dw 2
;		db 0A5h,0FAh
;		db 05Ah,0F5h
;D174D
;		db 000h,0E9h,02bh,025h,021h,0E9h
;		db 00fh,0F0h
;		dw 0ah
;		db 085h,0f8h
;		db 01ah,0f1h
;		db 0e5h,0feh
;		db 01ah,0f1h
;		db 09ah,0f9h
;		db 0d5h,0fdh
;		db 0b5h,0fbh
;		db 0fah,0ffh
;		db 09ah,0f9h
;		db 0e5h,0feh
;V4001D
;		db 0e9h,021h,0e7h,0e7h,02bh,0e3h
;		db 0c0h,0fch
;		dw 4
;		db 0c0h,0fch
;		db 019h,0f2h
;		db 026h,0f1h
;		db 03fh,0f3h
;V4011D
;		db 0e9h,021h,021h,0e7h,02bh,0e3h
;		db 0c0h,0fch
;		dw 4
;		db 0c0h,0fch
;		db 0d9h,0feh
;		db 0e6h,0fdh
;		db 03fh,0f3h
;V4030D
;		db 0e9h,0e7h,0adh,0e7h,02bh,0e3h
;		db 0c0h,0fch
;		dw 4
;		db 000h,0f0h
;		db 0d9h,0feh
;		db 0e6h,0fdh
;		db 03fh,0f3h
;
		end
