; Programm
; Melodiegenerator
; Autor: Gunther Zielosko
; "Hinweise zur Anwendung des Lerncomputers LC 80", Teil 3, Seite 85ff
;------------------------------------------------------------------------------

		CPU Z80

		org 0000h

; Hauptprogramm

M1:	INC IX			;IX solange er-
	LD SP, IX		;hhen, bis
	LD HL, 0000		;niederwertigste
	ADD HL, SP		;7 Bit = 0
	LD A, L			;(Umweg ber
	AND 7Fh			;Stackpointer
	CP 00			;und HL-Register)
	JR NZ,M1
	BIT 7, L		;Ist Bit 7 des
	JR NZ, M2		;L-Registers
	BIT 0, H		;oder eines der
	JR NZ, M2		;Bits 0 oder 1
	BIT 1, H		;des H-Registers
	JR NZ, M2		;= 1?, wenn nicht,
	JR M1			;IX weiter erhhen
M2:	LD SP, IX		;Bits 10 ... 15
	LD HL, 0000		;des Indexregi-
	ADD HL, SP		;sters IX werden
	EX DE, HL		;0 gesetzt (Umweg
	LD A, D			;ber SP, HL und
	AND 03			;DE)
	LD D, A			;Jetzt ist ein
	LD IX, 0000		;Liedanfang im
	ADD IX, DE		;Register IX.
	LD A, 0Fh		;PIO (D 206) in
	OUT 0F7h, A		;Mode Ausgabe (PB)
M3:	LD A, (IX + 00)		;Tonerzeugungspro-
	ADD A, A		;gramm wie LC-80
	JR M4
	JR M9			;RESTART 38 HALT
M4:	NOP
	NOP
	JR C, M9
	LD C, 00
	BIT 6, A
	JR NZ, M5
	SET 1, C
M5:	AND 3Fh
	LD HL, 00B4h		;Tontabelle 00B4
	LD E, A
	LD D, 00
	ADD HL, DE
	LD E, (HL)
	INC HL
	LD D, (HL)
	INC IX
	LD H, (IX + 00)
	LD A, 0FFh
M6:	LD L, D
M7:	OUT 0F5h, A		;PIO-Ausgabe
	LD B, E
M8:	NOP
	DJNZ M8
	XOR C
	DEC L
	JR NZ, M7
	DEC H
	JR NZ, M6
	INC IX
	JR M3
M9:	HALT

;Tonhhen- und -lngentabelle

	org 00B4h

	db 70h, 18h
	db 6Ah, 1Ah
	db 64h, 1Bh
	db 5Eh, 1Dh
	db 59h, 1Eh
	db 54h, 20h
	db 4Fh, 22h
	db 4Bh, 24h
	db 46h, 26h
	db 42h, 29h
	db 3Fh, 2Bh
	db 3Bh, 2Eh
	db 38h, 31h
	db 35h, 33h
	db 32h, 37h
	db 2Fh, 3Ah
	db 2Ch, 3Dh
	db 2Ah, 41h
	db 27h, 45h
	db 25h, 49h
	db 23h, 4Dh
	db 21h, 52h
	db 1Fh, 57h
	db 1Dh, 5Ch
	db 1Bh, 62h
	db 1Ah, 67h
	db 18h, 6Eh
	db 17h, 74h
	db 16h, 7Bh
	db 14h, 82h
	db 13h, 8Ah
	db 12h, 92h

; Melodien

; Horch, was kommt von drauen rein ...
; Auf, auf zum frhlichen Jagen ...
; Das Lieben bringt gro' Freud ...
; Wenn alle Brnnlein flieen ...
; Hoch auf dem gelben Wagen ...
; Mu i' denn ...
; Es blies ein Jger wohl in sein Horn ...

;1
	org 0080h
	db 0Bh, 04h
	db 0Dh, 04h
	db 0Fh, 04h	
	db 10h, 04h	
	db 12h, 04h	
	db 14h, 04h	
	db 12h, 08h
	db 10h, 04h
	db 0Dh, 04h
	db 16h, 08h
	db 12h, 04h
	db 0Fh, 04h
	db 17h, 08h
	db 80h

;2
	org 100h
	db 0Bh, 08h
	db 10h, 0Bh
	db 0Bh, 04h
	db 10h, 08h
	db 14h, 03h
	db 20h, 01h
	db 14h, 04h
	db 10h, 10h
	db 0Bh, 08h
	db 10h, 04h
	db 14h, 04h
	db 12h, 08h
	db 0Bh, 07h
	db 20h, 01h
	db 0Bh, 08h
	db 0Dh, 04h
	db 0Fh, 04h
	db 10h, 10h
	db 80h

;3
	org 0180h
	db 0Bh, 08h
	db 10h, 0Bh
	db 12h, 04h
	db 14h, 08h
	db 15h, 04h
	db 19h, 04h
	db 17h, 10h
	db 20h, 08h
	db 10h, 04h
	db 14h, 04h
	db 17h, 07h
	db 20h, 01h
	db 17h, 08h
	db 15h, 07h
	db 20h, 01h
	db 15h, 08h
	db 14h, 10h
	db 80h

;4
	org 0200h
	db 00h, 08h
	db 12h, 07h
	db 20h, 01h
	db 12h, 08h
	db 14h, 07h
	db 20h, 01h
	db 14h, 08h
	db 16h, 0Bh
	db 14h, 04h
	db 12h, 08h
	db 16h, 08h
	db 17h, 08h
	db 16h, 08h
	db 14h, 08h
	db 12h, 08h
	db 14h, 10h
	db 80h

;5
	org 0280h
	db 0Bh, 08h
	db 10h, 04h
	db 12h, 04h
	db 14h, 08h
	db 17h, 08h
	db 14h, 08h
	db 12h, 08h
	db 10h, 10h
	db 0Bh, 08h
	db 10h, 04h
	db 12h, 04h
	db 14h, 08h
	db 12h, 08h
	db 10h, 10h
	db 80h

;6
	org 0300h
	db 0Bh, 04h
	db 0Dh, 04h
	db 0Fh, 07h
	db 20h, 01h
	db 0Fh, 04h
	db 12h, 04h
	db 10h, 07h
	db 20h, 01h
	db 10h, 04h
	db 14h, 04h
	db 12h, 06h
	db 14h, 02h
	db 12h, 04h
	db 10h, 04h
	db 0Fh, 10h
	db 12h, 06h
	db 14h, 02h
	db 12h, 04h
	db 10h, 04h
	db 0Fh, 07h
	db 20h, 01h
	db 01h, 04h
	db 12h, 04h
	db 10h, 07h
	db 20h, 01h
	db 10h, 08h
	db 0Dh, 08h
	db 12h, 08h
	db 01h, 10h
	db 80h

;7
	org 0380h
	db 0Dh, 08h
	db 12h, 07h
	db 20h, 01h
	db 12h, 07h
	db 20h, 01h
	db 12h, 07h
	db 20h, 01h
	db 11h, 04h
	db 0Fh, 04h
	db 0Dh, 10h
	db 0Fh, 10h
	db 0Dh, 08h
	db 12h, 08h
	db 16h, 08h
	db 19h, 07h
	db 20h, 01h
	db 19h, 10h
	db 17h, 08h
	db 19h, 08h
	db 16h, 12h
	db 80h

	end

; alternativ: Weihnachtslieder

;Alle Jahre wieder ...
;Lat uns froh und munter sein ...
;Leise rieselt der Schnee ...
;Kling, Glckchen kling ...
;Morgen, Kinder, wird's was geben ...
;Ihr Kinderlein kommet ...
;Vom Himmel hoch ...


;1
	org 0080h

	db 12h, 0Bh
	db 14h, 04h
	db 12h, 08h
	db 10h, 08h
	db 0Fh, 10h
	db 0Dh, 10h
	db 0Bh, 08h
	db 0Dh, 04h
	db 0Fh, 04h
	db 10h, 08h
	db 0Fh, 08h
	db 0Dh, 20h
	db 0Fh, 08h
	db 12h, 08h
	db 14h, 08h
	db 12h, 08h
	db 17h, 10h
	db 16h, 08h
	db 14h, 08h
	db 12h, 08h
	db 10h, 04h
	db 0Fh, 04h
	db 10h, 08h
	db 12h, 08h
	db 0Fh, 18h
	db 80h

;2
	org 0100h
	db 12h, 07h
	db 20h, 01h
	db 12h, 07h
	db 20h, 01h
	db 12h, 04h
	db 14h, 04h
	db 12h, 04h
	db 10h, 04h
	db 0Fh, 07h
	db 20h, 01h
	db 0Fh, 07h
	db 20h, 01h
	db 0Fh, 10h
	db 10h, 07h
	db 20h, 01h
	db 10h, 07h
	db 20h, 01h
	db 10h, 04h
	db 12h, 04h
	db 10h, 04h
	db 0Fh, 04h
	db 0Dh, 07h
	db 20h, 01h
	db 0Dh, 07h
	db 20h, 01h
	db 0Dh, 10h
	db 0Bh, 08h
	db 0Dh, 08h
	db 0Fh, 08h
	db 10h, 08h
	db 12h, 04h
	db 14h, 04h
	db 12h, 04h
	db 14h, 04h
	db 12h, 10h
	db 17h, 08h
	db 12h, 07h
	db 20h, 01h
	db 12h, 04h
	db 14h, 04h
	db 12h, 04h
	db 10h, 04h
	db 0Fh, 08h
	db 0Dh, 08h	; statt 05 wie in PDF :-)
	db 12h, 10h
	db 17h, 08h
	db 12h, 07h
	db 20h, 01h
	db 12h, 04h
	db 14h, 04h
	db 12h, 04h
	db 10h, 04h
	db 0Fh, 08h
	db 0Dh, 08h
	db 0Bh, 10h
	db 80h

;3
	org 180h
	db 14h, 0Fh
	db 20h, 01h
	db 14h, 08h
	db 12h, 0Bh
	db 14h, 04h
	db 12h, 08h
	db 10h, 23h
	db 20h, 01h
	db 10h, 10h
	db 0Dh, 08h
	db 10h, 0Bh
	db 0Fh, 04h
	db 0Dh, 08h
	db 0Bh, 24h
	db 12h, 0Bh
	db 11h, 04h
	db 12h, 08h
	db 15h, 08h
	db 14h, 08h
	db 12h, 08h
	db 10h, 24h
	db 12h, 0Bh
	db 0Dh, 03h
	db 20h, 01h
	db 0Dh, 08h
	db 0Fh, 08h
	db 0Dh, 08h
	db 0Fh, 08h
	db 10h, 24h
	db 80h

;4
	org 0200h
	db 17h, 10h
	db 14h, 08h
	db 15h, 08h
	db 17h, 04h
	db 19h, 04h
	db 17h, 04h
	db 19h, 04h
	db 17h, 10h
	db 15h, 10h
	db 12h, 08h
	db 17h, 08h
	db 14h, 18h
	db 20h, 08h
	db 12h, 07h
	db 20h, 01h
	db 12h, 08h
	db 14h, 08h
	db 10h, 08h
	db 14h, 10h
	db 12h, 10h
	db 15h, 07h
	db 20h, 01h
	db 15h, 08h
	db 17h, 08h
	db 12h, 08h
	db 15h, 10h
	db 14h, 10h
	db 12h, 07h
	db 20h, 01h
	db 12h, 08h
	db 14h, 08h
	db 16h, 08h
	db 17h, 10h
	db 12h, 10h
	db 14h, 08h
	db 19h, 08h
	db 17h, 08h
	db 16h, 08h
	db 19h, 10h
	db 17h, 0Fh
	db 20h, 01h
	db 17h, 10h
	db 14h, 08h
	db 15h, 08h
	db 17h, 04h
	db 19h, 04h
	db 17h, 04h
	db 19h, 04h
	db 17h, 10h
	db 15h, 10h
	db 12h, 08h
	db 17h, 08h
	db 14h, 18h
	db 80h
	
;5
	org 280h
	db 10h, 08h
	db 0Bh, 08h
	db 0Dh, 08h
	db 0Bh, 08h
	db 0Dh, 04h
	db 10h, 04h
	db 0Fh, 04h
	db 12h, 04h
	db 10h, 08h
	db 0Bh, 08h
	db 14h, 07h
	db 20h, 01h
	db 14h, 04h
	db 15h, 04h
	db 17h, 08h
	db 14h, 08h
	db 15h, 08h
	db 14h, 08h
	db 12h, 10h
	db 10h, 08h
	db 0Bh, 08h
	db 0Dh, 08h
	db 0Bh, 08h
	db 0Dh, 04h
	db 10h, 04h
	db 0Fh, 04h
	db 12h, 04h
	db 10h, 08h
	db 0Bh, 08h
	db 14h, 07h
	db 20h, 01h
	db 14h, 04h
	db 15h, 04h
	db 17h, 08h
	db 14h, 08h
	db 15h, 08h
	db 14h, 08h
	db 12h, 10h
	db 15h, 07h
	db 20h, 01h
	db 15h, 08h
	db 19h, 07h
	db 20h, 01h
	db 19h, 08h
	db 12h, 07h
	db 20h, 01h
	db 12h, 08h
	db 17h, 10h
	db 10h, 07h
	db 20h, 01h
	db 10h, 08h
	db 15h, 07h
	db 20h, 01h
	db 15h, 08h
	db 14h, 04h
	db 12h, 04h
	db 10h, 04h
	db 0Fh, 04h
	db 10h, 10h
	db 80h
	
;6
	org 300h
	db 12h, 07h
	db 20h, 01h
	db 12h, 10h
	db 0Fh, 08h
	db 12h, 07h
	db 20h, 01h
	db 12h, 10h
	db 0Fh, 08h
	db 12h, 08h
	db 10h, 10h
	db 0Dh, 08h
	db 10h, 08h
	db 0Fh, 18h
	db 12h, 07h
	db 20h, 01h
	db 12h, 10h
	db 0Fh, 08h
	db 12h, 07h
	db 20h, 01h
	db 12h, 10h
	db 0Fh, 08h
	db 12h, 08h
	db 10h, 10h
	db 0Dh, 08h
	db 10h, 08h
	db 0Fh, 17h
	db 20h, 01h
	db 0Fh, 08h
	db 0Dh, 0Fh
	db 20h, 01h
	db 0Dh, 07h
	db 20h, 01h
	db 0Dh, 08h
	db 10h, 0Fh
	db 20h, 01h
	db 10h, 07h
	db 20h, 01h
	db 10h, 08h
	db 0Fh, 0Fh
	db 20h, 01h
	db 0Fh, 07h
	db 20h, 01h
	db 0Fh, 08h
	db 14h, 17h
	db 20h, 01h
	db 14h, 08h
	db 12h, 0Fh
	db 20h, 01h
	db 12h, 07h
	db 20h, 01h
	db 12h, 08h
	db 17h, 10h
	db 12h, 08h
	db 0Fh, 08h
	db 10h, 10h
	db 0Dh, 08h
	db 0Ah, 08h
	db 0Bh, 18h
	db 80h
	
;7
	org 380h
	db 17h, 10h
	db 16h, 10h
	db 14h, 10h
	db 16h, 10h
	db 12h, 10h
	db 14h, 10h
	db 16h, 10h
	db 17h, 10h
	db 20h, 08h
	db 17h, 07h
	db 20h, 01h
	db 17h, 10h
	db 12h, 0Fh
	db 20h, 01h
	db 12h, 10h
	db 0Fh, 10h
	db 12h, 10h
	db 10h, 10h
	db 0Fh, 10h
	db 20h, 08h
	db 0Fh, 08h
	db 14h, 0Fh
	db 20h, 01h
	db 14h, 10h
	db 12h, 10h
	db 16h, 10h
	db 17h, 10h
	db 14h, 10h
	db 12h, 10h
	db 20h, 08h
	db 17h, 08h
	db 16h, 10h
	db 14h, 10h
	db 12h, 10h
	db 14h, 10h
	db 10h, 08h
	db 0Fh, 08h
	db 0Dh, 10h
	db 0Bh, 10h
	db 80h

	end
	