; Programm
; Sterntaler (fallende Leuchtbalken)
; Autor: Gunther Zielosko
; "Hinweise zur Anwendung des Lerncomputers LC 80", Teil 3, Seite 64-69
;------------------------------------------------------------------------------
;------------------------------------------------------------------------------

		CPU Z80

		include	lc80

		org 2000h

; Lschen des Anzeige- und Speicherbereiches
h0:		ld	b,10h
		ld	hl,2210h
h1:		ld	(hl),0
		dec	hl
		djnz	h1
		ld	ix,2200h
; Punkt setzen
		ld	(hl),10h		
		ld	a,l
		ld	(2220h),a		; Position des Punktes in 2220
		ld	a,1ch			; Startpunkt des Rckwrtsszhlers
		ld	(2222h),a
h2:		ld	d,20h
h3:		call	sterne
; Schrittweise Erhhung der Geschwindigkeit (Stufengre in 2030 vernderbar,
; Startwert in 2015), Stufen 01, 02, 04
		ld	a,(2222h)
		ld	b,a
h4:		push	bc
		call	faenger
		pop	bc
		djnz	h4
		dec	d
		jr	nz,h3
		ld	a,(2222h)
		sub	02			; 04, 01
		jr	z,h5
		ld	(2222h),a
		jr	h2
h5:		ld	de,(2208h)
; Punktestand im Anzeigebereich 2, Anzeige
		call	adrsdp
		ld	ix,DATLED
h6:		call	dak1
		cp	10h			; '+'?
		jr	z,h0
		jr	h6
		
		ds	4
;
faenger:
		ld	a,(2220h)		; Pos. Fnger
		ld	l,a			; als HL-Wert aufbereiten
		ld	h,hi(2200h)
		ld	b,8			; Geschwindigkeit
		ld	a,0ffh
f1:		call	dak2
		djnz	f1
		cp	04h			; '0'?
		jr	z,f2
		cp	07h			; '3'?
		jr	z,f3
		jr	f4
; linke Grenze erreicht? wenn nicht, Punkt nach links verschieben
f2:		ld	a,5
		cp	l
		jr	z,f4
		res	4,(hl)
		inc	hl
		set	4,(hl)
		jr	f4
; rechte Grenze erreicht? wenn nicht, Punkt nach rechts verschieben
f3:		ld	a,0
		cp	l
		jr	z,f4
		res	4,(hl)
		dec	hl
		set	4,(hl)
; neue Position des Fngers eintragen
f4:		ld	a,l
		ld	(2220h),a
		ret
;	
		ds	1
sterne:
; Prfung, ob im Anzeigebereich 1 irgendwo Bit 7 (unterer Balken) gesetzt ist
		ld	b,7
		ld	hl,2200h
s1:		bit	7,(hl)
		call	nz,vergl
		res	7,(hl)
		inc	hl
		djnz	s1
; Prfung, ob im Anzeigebereich Bit 3 (mittlerer Balken) gesetzt ist, 
; diesen lschen, Bit 7 setzen (Verschiebung nach unten)
		ld	b,7
		ld	hl,2200h
s2:		bit	3,(hl)
		jr	z,s3
		set	7,(hl)
		res	3,(hl)
s3:		inc	hl
		djnz	s2
; Prfung, auf Bit 2 (oberer Balken), siesen lschen, Bit 3 setzen 
; (Verschiebung nach unten)
		ld	b,7
		ld	hl,2200h
s4:		bit	2,(hl)
		jr	z,s5
		set	3,(hl)
		res	2,(hl)
s5:		inc	hl
		djnz	s4
; an zuflliger Stelle neues Bit 2 (oberer Balken) setzen
		ld	a,r
		and	07h
		ld	l,a
		ld	h,hi(2200h)
		set	2,(hl)
		ret
;
vergl:
		ld	a,(2220h)		; Position Fnger
		cp	l
		jr	nz,v2
; Punktezhler (Einer, Zehner) um 1 erhhen
		ld	a,(2208h)
		add	a,1
		daa
		ld	(2208h),a
		jr	nc,v1
; wenn bertrag, Punktezhler (Hunderter, Tausender) um 1 erhhen
		ld	a,(2209h)
		add	a,1
		daa
		ld	(2209h),a
v1:		push	bc
		push	hl
		push	de
		call	SOU1K			; Ton bei Treffer, im Original SOU1K+1
		pop	de
; die rechten beiden Stellen des Anzeigebreichs 2 lschen
		ld	hl,DATLED
		ld	(hl),0
		inc	hl
		ld	(hl),0
		pop	hl
		pop	bc
v2:		ret		
		
;2200-2205	Anzeigebereich 1 (Spielfeld)
;2208		Punktzhler (Einer, Zehner)
;2209		Punktzhler (Hunderter, Tausender)
;2220		aktuelle Position des Fngers
;2222		aktuelle Geschwindigkeit der fallenden Balken

		end